<template>
  <div class="app-container" style="padding: 10px;">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('责任人')" prop="responsible">
        <el-input
          v-model="queryParams.responsible"
          :placeholder="$t('请输入') + $t('责任人')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('行动')" prop="action">
        <el-input
          v-model="queryParams.action"
          :placeholder="$t('请输入') + $t('行动')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('截止日期')" prop="deadline">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.deadline"
          type="date"
          value-format="yyyy-MM-dd"
          :placeholder="$t('请选择') + $t('截止日期')">
        </el-date-picker>
      </el-form-item>
      <el-form-item :label="$t('状态')" prop="status">
        <el-select v-model="queryParams.status" :placeholder="$t('请选择') + $t('状态')" clearable size="small">
          <el-option
            v-for="dict in statusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('备注')" prop="remarks">
        <el-input
          v-model="queryParams.remarks"
          :placeholder="$t('请输入') + $t('备注')"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['plant:meeting:add']"
        >{{ $t('新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['plant:meeting:edit']"
        >{{ $t('修改') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['plant:meeting:remove']"
        >{{ $t('删除') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-s-data"
          size="mini"
          @click="handleData"
        >{{ $t('数据分析') }}</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="actionlistList" @selection-change="handleSelectionChange" :row-class-name="rowClassName" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column :label="$t('责任人')" width="100" align="center" prop="respName" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('行动')" width="400"  align="center" prop="action" />
      <el-table-column :label="$t('截止日期')" align="center" prop="deadline" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.deadline, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('状态')" align="center" prop="status" :formatter="statusFormat" />
      <el-table-column :label="$t('录入日期')" align="center" prop="inputdate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.inputdate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="录入人" align="center" prop="createrCode" :show-overflow-tooltip="true"/>

      <el-table-column :label="$t('备注')" align="center" prop="remarks" :show-overflow-tooltip="true"/>
      <el-table-column label="更新人" align="center" prop="updaterCode" :show-overflow-tooltip="true"/>
      <el-table-column label="更新日期" align="center" prop="updatedate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updatedate, '{y}-{m}-{d}') }}</span>
        </template>c
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" width="120" class-name="small-padding">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-if="checkPermi(['plant:meeting:edit']) "
          >{{ $t('修改') }}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-if="checkPermi(['plant:meeting:remove'])"
          >{{ $t('删除') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改装置会议执行对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">

        <el-form-item :label="$t('责任人')" prop="responsible">
          <el-select v-if="form.isPerson == '1' " multiple style="width: 220px" v-model="respList" filterable :placeholder="$t('请选择') + $t('负责人姓名')" filterable >
            <el-option
              v-for="dict in stffmgrOptions"
              :key="dict.id"
              :label="dict.name"
              :value="dict.staffid">
              <span style="float: left">{{ dict.name }}</span>
              <span style="float: right; color: #8492a6; font-size: 13px">{{ dict.staffid }}</span>
            </el-option>
          </el-select>
          <el-select v-else style="width: 220px" multiple v-model="positionList" filterable placeholder="请选择岗位" filterable >
            <el-option
              v-for="dict in actualpostOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
            <el-radio @change="changeIsPerson"  style="margin-left: 50px" v-model="form.isPerson" label="1">指定人员</el-radio>
            <el-radio @change="changeIsPerson" v-model="form.isPerson" label="2">指定岗位</el-radio>
        </el-form-item>
        <el-form-item :label="$t('行动')" prop="action">
          <el-input v-model="form.action" :placeholder="$t('请输入') + $t('行动')" />
        </el-form-item>
        <el-form-item :label="$t('截止日期')" prop="deadline">
          <el-date-picker clearable size="small" style="width: 200px"
            v-model="form.deadline"
            type="date"
            value-format="yyyy-MM-dd"
            :placeholder="$t('请选择') + $t('截止日期')">
          </el-date-picker>
        </el-form-item>
        <el-form-item :label="$t('状态')" prop="status">
          <el-select v-model="form.status" :placeholder="$t('请选择') + $t('状态')">
            <el-option
              v-for="dict in statusOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('录入日期')" prop="inputdate">
          <el-date-picker clearable size="small" style="width: 200px"
            v-model="form.inputdate"
            type="date"
            value-format="yyyy-MM-dd"
            :placeholder="$t('请选择') + $t('录入日期')">
          </el-date-picker>
        </el-form-item>

        <el-form-item :label="$t('备注')" prop="remarks">
          <el-input v-model="form.remarks" :placeholder="$t('请输入') + $t('备注')" />
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
      <!-- 用户导入对话框 -->
      <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
          <el-upload
                  ref="upload"
                  :limit="1"
                  accept=".xlsx, .xls"
                  :headers="upload.headers"
                  :action="upload.url + '?updateSupport=' + upload.updateSupport"
                  :disabled="upload.isUploading"
                  :on-progress="handleFileUploadProgress"
                  :on-success="handleFileSuccess"
                  :auto-upload="false"
                  drag
          >
              <i class="el-icon-upload"></i>
              <div class="el-upload__text">
                  {{ $t('将文件拖到此处，或') }}
                  <em>{{ $t('点击上传') }}</em>
              </div>
              <div class="el-upload__tip" slot="tip">
                  <!--<el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据-->
                  <el-link type="info" style="font-size:12px" @click="importTemplate">{{ $t('下载模板') }}</el-link>
              </div>
              <div class="el-upload__tip" style="color:red" slot="tip">{{ $t('提示：仅允许导入“xls”或“xlsx”格式文件！') }}</div>
          </el-upload>
          <div slot="footer" class="dialog-footer">
              <el-button type="primary" @click="submitFileForm">{{ $t('确 定') }}</el-button>
              <el-button @click="upload.open = false">{{ $t('取 消') }}</el-button>
          </div>
      </el-dialog>
    <el-drawer
      :title="$t('数据分析')"
      size="600px"
      :visible.sync="drawer"
      :direction="direction">
      <el-row>
        <el-col>
          <el-card class="box-card" shadow="hover">
            <div slot="header" class="clearfix">
              <span>{{ $t('状态统计') }}</span>
            </div>
            <div class="text item">
              <action-status-data></action-status-data>
            </div>
          </el-card>
        </el-col>
      </el-row>
    </el-drawer>
  </div>
</template>

<script>
  import {
    addActionlist,
    delActionlist,
    exportActionlist,
    getActionlist,
    importTemplate,
    listActionlist,
    updateActionlist
  } from "@/api/plant/actionlist";
  import {treeselect} from "@/api/system/dept";
  import {listStaffmgrByDeptAndTeam} from "@/api/plant/staffmgr";
  import {getToken} from "@/utils/auth";
  import Treeselect from "@riophae/vue-treeselect";
  import "@riophae/vue-treeselect/dist/vue-treeselect.css";
  import ActionStatusData from "./actionStatusData";
  import {listPostUser} from "@/api/system/user";
  import {checkPermi} from "@/utils/permission";

  export default {
  name: "Actionlist",
  components: {ActionStatusData, Treeselect },
  data() {
    return {
      drawer: false,
      direction: 'rtl',
      // 遮罩层
      loading: true,
      staffId:'',
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 装置会议执行表格数据
      actionlistList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
      // 装置字典
      plantCodeOptions: [],
      stffmgrOptions: [],
      actualpostOptions: [],
      respList: [],
      positionList: [],
      // 状态字典
      statusOptions: [],
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/plant/actionlist/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
        responsible: null,
        action: null,
        deadline: null,
        status: null,
        remarks: null,
        meetingId: null},
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        action: [
          { required: true, message: '不能为空', trigger: "change" }
        ],
        inputdate: [
          { required: true, message: '不能为空', trigger: "change" }
        ],
        status: [
          { required: true, message: '不能为空', trigger: "change" }
        ],
      }
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
    computed: {
      checkPermi() {
        return checkPermi;
      },
    },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = (document.body.clientHeight - 80) * 0.8
      })
    this.queryParams.meetingId = this.$route.params && this.$route.params.tableId;
    this.getList();
    // this.getTreeselect();
    this.getStaffmar()
    // this.getDicts("PLANT_DIVIDE").then(response => {
    //   this.plantCodeOptions = response.data;
    // });
    this.getDicts("ACTION_STATUS").then(response => {
      this.statusOptions = response.data;
    });
    this.getDicts("ACTUALPOST").then(response => {
      this.actualpostOptions = response.data;
    });
  },
  methods: {
    /** 查询装置会议执行列表 */
    getList() {
      this.loading = true;
      listActionlist(this.queryParams).then(response => {
        this.actionlistList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getStaffId(resp,name){
      if (resp) {
        if (resp.includes(this.$store.state.user.staffId)){
          return true
        }
      }
      if (name == this.$store.state.user.nickName) {
        return true
      }
      return false
    },
    //获取人员表
    getStaffmar() {
      let param = {unit: '103'}
      listStaffmgrByDeptAndTeam(param).then(response => {
        this.stffmgrOptions = response.rows;
      });
    },
    changeIsPerson(){
      this.respList = []
      this.positionList = []
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 装置字典翻译
    plantCodeFormat(row, column) {
      return this.selectDictLabel(this.plantCodeOptions, row.plantCode);
    },
    // 状态字典翻译
    statusFormat(row, column) {
      return this.selectDictLabel(this.statusOptions, row.status);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        plantCode: null,
        responsible: null,
        action: null,
        deadline: null,
        status: null,
        inputdate: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null,
        meetingId: null,
        isHis: null,
        isPerson: '1',
        position: null,
      };
      this.respList = []
      this.positionList = []
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    rowClassName({ row }) {
      // 根据 row 对象的属性值判断并返回相应的类名
      if (row.isNew == 1) {
        return 'blue-row';
      }
      // 如果不需要改变样式，返回空字符串
      return '';
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      if (this.$route.params.tableId) {
        this.form.meetingId = this.$route.params.tableId
        this.form.isHis = 1
      }
      // this.form.inputdate = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), 0, 0)
      this.form.inputdate = new Date()
      this.respList = [this.$store.state.user.staffId]
      this.open = true;
      this.title = this.$t('新增') + " " + this.$t('装置会议执行');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getActionlist(id).then(response => {
        this.form = response.data;
        if (response.data.responsible){
          this.respList = response.data.responsible.split(",")
        }
        if (response.data.position) {
          this.positionList = response.data.position.split(",")
        }
        this.open = true;
        this.title = this.$t('修改')  + this.$t('装置会议执行');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.responsible = this.respList.join(",")
          this.form.position = this.positionList.join(",")
          if (this.form.id != null) {
            updateActionlist(this.form).then(response => {
              this.msgSuccess(this.$t('修改成功'));
              this.open = false;
              this.getList();
            });
          } else {
            addActionlist(this.form).then(response => {
              this.msgSuccess(this.$t('新增成功'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return delActionlist(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess(this.$t('删除成功'));
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm(this.$t('是否确认导出所有装置会议执行数据项?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return exportActionlist(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = this.$t('用户导入');
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, this.$t('导入结果'), { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      },
    //数据分析
    handleData(){
      this.drawer = true
    }
  }
};
</script>

<style lang="scss" scoped>
.blue-row {
  color: blue;
}
</style>
